unit UfrmSplash;

// |===========================================================================|
// | unit UfrmSplash                                                           |
// | Copyright  2006 F.BASSO                                                  |
// |___________________________________________________________________________|
// | Unit UfrmSplash de l'application Scanlog contenant toute la partie de    |
// | l'affichage du splash                                                     |
// |___________________________________________________________________________|
// | Ce programme est libre, vous pouvez le redistribuer et ou le modifier     |
// | selon les termes de la Licence Publique Gnrale GNU publie par la       |
// | Free Software Foundation .                                                |
// | Ce programme est distribu car potentiellement utile,                     |
// | mais SANS AUCUNE GARANTIE, ni explicite ni implicite,                     |
// | y compris les garanties de commercialisation ou d'adaptation              |
// | dans un but spcifique.                                                   |
// | Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.    |
// |                                                                           |
// | anbasso@wanadoo.fr                                                        |
// |___________________________________________________________________________|
// | Version 1.0.0.0 Cration de l'unit                                       |
// |===========================================================================|


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, jpeg;

type
  TfrmSplash = class(TForm)
    Timer1: TTimer;
    Panel1: TPanel;
    lblTitre: TLabel;
    lblVersion: TLabel;
    lblCopyright: TLabel;
    Image1: TImage;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private

// ****************************************************************************
// * Dclarations prives                                                     *
// ****************************************************************************

  public

// ****************************************************************************
// * Dclarations publiques                                                   *
// ****************************************************************************

    class procedure AfficheMessage(texte: string); static;
    class procedure Ferme; static;
    class Procedure Executer;
    class Procedure AfficheErreur(texte: string); static;
  end;

var
  frmSplash: TfrmSplash;

implementation

{$R *.dfm}

uses UfonctionsDiv ;

// #===========================================================================#
// #===========================================================================#
// #                                                                           #
// # Partie Prive                                                             #
// #                                                                           #
// #===========================================================================#
// #===========================================================================#


class procedure TfrmSplash.Executer ;

//  ___________________________________________________________________________
// | procedure TFrmSplash.Executer                                             |
// | _________________________________________________________________________ |
// || Affiche la fentre et rcupre les infos                                ||
// ||_________________________________________________________________________||
// |___________________________________________________________________________|

begin
  if not Assigned(FrmSplash) then
    FrmSplash := TFrmSplash.Create(Application);
  with FrmSplash do
  begin
    lblTitre.caption := StrLectureNomProduit ;
    lblCopyright.caption := StrLectureCopyright ;
    lblVersion.Caption := 'Version ' + StrLectureVersion ;
    Show;
    repaint;
  end;

end;

class procedure TFrmSplash.AfficheMessage( texte : string );

//  ___________________________________________________________________________
// | procedure TFrmSplash.AfficheMessage                                       |
// | _________________________________________________________________________ |
// || Ajoute un message dans la listebox                                      ||
// ||_________________________________________________________________________||
// || Entres | texte : string                                                ||
// ||         |   Texte  afficher                                            ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  if not Assigned(FrmSplash) then exit;
  FrmSplash.memo1.Lines.Add(texte);
end;

class procedure TFrmSplash.AfficheErreur( texte : string );

//  ___________________________________________________________________________
// | procedure TFrmSplash.AfficheErreur                                        |
// | _________________________________________________________________________ |
// || Ajoute un message dans la listebox et affiche le bouton                 ||
// ||_________________________________________________________________________||
// || Entres | texte : string                                                ||
// ||         |   Texte  afficher                                            ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  if not Assigned(FrmSplash) then exit;
  FrmSplash.memo1.Lines.Add(texte);
end;

class procedure TFrmSplash.Ferme;

//  ___________________________________________________________________________
// | procedure TFrmSplash.Ferme                                                |
// | _________________________________________________________________________ |
// || Ferme la fentre                                                        ||
// ||_________________________________________________________________________||
// |___________________________________________________________________________|

begin
  if not Assigned(FrmSplash)then exit;
  FrmSplash.Timer1.Interval := 2000;
  FrmSplash.Timer1.Enabled := true;
end;

// #===========================================================================#
// #===========================================================================#
// #                                                                           #
// # Partie Evnementiel                                                       #
// #                                                                           #
// #===========================================================================#
// #===========================================================================#

procedure TFrmSplash.FormCreate(Sender: TObject);
begin
  memo1.Lines.Add('Dmarrage');
end;

procedure TFrmSplash.Timer1Timer(Sender: TObject);
begin
  timer1.Interval := 0;
  close;
end;

end.
