unit uPing;

// |===========================================================================|
// | unit uPing                                                                 |
// | Copyright  2007 F.BASSO                                                  |
// |___________________________________________________________________________|
// | Unit encapsulant les API de PING des DLL ICMP.DLL er IPHLPAPI.DLL        |
// | Permetant de faire des requtes de ping                                   |
// |___________________________________________________________________________|
// | Ce programme est libre, vous pouvez le redistribuer et ou le modifier     |
// | selon les termes de la Licence Publique Gnrale GNU publie par la       |
// | Free Software Foundation .                                                |
// | Ce programme est distribu car potentiellement utile,                     |
// | mais SANS AUCUNE GARANTIE, ni explicite ni implicite,                     |
// | y compris les garanties de commercialisation ou d'adaptation              |
// | dans un but spcifique.                                                   |
// | Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.    |
// |                                                                           |
// | anbasso@wanadoo.fr                                                        |
// |___________________________________________________________________________|
// | Versions                                                                  |
// |   1.0.0.0 Cration de l'unit                                             |
// |===========================================================================|


interface

uses
  windows, SysUtils, Classes, WinSock,math;

const
  IcmpDLL = 'icmp.dll';
  IphlpapiDLL = 'Iphlpapi.dll';   // Dll  utiliser  partir de XP voir MSDN

  ICMP_SUCCESS                                = 0 ;          // Pas d'erreur
  ICMP_STATUS_BUFFER_TO_SMALL                 = 11001 ;      // Buffer trop petit
  ICMP_STATUS_DESTINATION_NET_UNREACH         = 11002 ;      // Rseau de destination non atteignable
  ICMP_STATUS_DESTINATION_HOST_UNREACH        = 11003 ;      // Hte destination non atteignable
  ICMP_STATUS_DESTINATION_PROTOCOL_UNREACH    = 11004 ;      // protocole de destination non atteignable
  ICMP_STATUS_DESTINATION_PORT_UNREACH        = 11005 ;      // port de destination non atteignable
  ICMP_STATUS_NO_RESOURCE                     = 11006 ;      // Pas de resources
  ICMP_STATUS_BAD_OPTION                      = 11007 ;      // Mauvaises options
  ICMP_STATUS_HARDWARE_ERROR                  = 11008 ;      // Erreur matriel
  ICMP_STATUS_LARGE_PACKET                    = 11009 ;      // Paquet trop grand
  ICMP_STATUS_REQUEST_TIMED_OUT               = 11010 ;      // Request timed out
  ICMP_STATUS_BAD_REQUEST                     = 11011 ;      // Mauvaise requte
  ICMP_STATUS_BAD_ROUTE                       = 11012 ;      // Mauvaise route
  ICMP_STATUS_TTL_EXPIRED_TRANSIT             = 11013 ;      // TTL  expir pendant le trajet
  ICMP_STATUS_TTL_EXPIRED_REASSEMBLY          = 11014 ;      // TTL  expir pendant le rassemblage
  ICMP_STATUS_PARAMETER                       = 11015 ;      // Problme de paramtrages
  ICMP_STATUS_SOURCE_QUENCH                   = 11016 ;      // Extinction de la source
  ICMP_STATUS_OPTION_TOO_BIG                  = 11017 ;      // Options trop grandes
  ICMP_STATUS_BAD_DESTINATION                 = 11018 ;      // Mauvaise destination
  ICMP_STATUS_ADDR_DELETED                    = 11019 ;      // Adresse supprime
  ICMP_STATUS_SPEC_MTU_CHANGE                 = 11020 ;      // Les specifications MTU ont chang
  ICMP_STATUS_MTU_CHANGE                      = 11021 ;      // la taille maximale du paquet IP a chang
  ICMP_STATUS_UNLOAD                          = 11022 ;      // dchargement
  ICMP_STATUS_ADDRESS_ADDED                   = 11023 ;      // Adresse ajout
  ICMP_STATUS_MEDIA_CONNECT                   = 11024 ;      // Mdia connect
  ICMP_STATUS_MEDIA_DISCONNECT                = 11025 ;      // Mdia dconnect
  ICMP_STATUS_BIND_ADAPTER                    = 11026 ;      // Adaptateur reli
  ICMP_STATUS_UNBIND_ADAPTER                  = 11027 ;      // Adaptateur non reli
  ICMP_STATUS_DEVICE_DOES_NOT_EXIST           = 11028 ;      // Matriel inexistant
  ICMP_STATUS_DUPLICATE_ADDRESS               = 11029 ;      // Doublon d'adresse
  ICMP_STATUS_INTERFACE_METRIC_CHANGE         = 11030 ;      // Distance de la route change
  ICMP_STATUS_RECONFIG_SECFLTR                = 11031 ;      // ?????
  ICMP_STATUS_NEGOTIATING_IPSEC               = 11032 ;      // Ngociation de l'IPSEC (Internet Protocol Security)
  ICMP_STATUS_INTERFACE_WOL_CAPABILITY_CHANGE = 11033 ;      // Changement des capacits de Wake on Lan
  ICMP_STATUS_DUPLICATE_IPADD                 = 11034 ;      // Doublon d'adresse IP
  ICMP_STATUS_GENERAL_FAILURE                 = 11050 ;      // Erreur gnrale
  ICMP_STATUS_PENDING                         = 11255 ;      // Ping en cours

type
  TicmpIPAddress   = Longword;                             // Adresse IP format comme un chiffre de 4 octets
  TicmpIPMask      = Longword;                             // Masque de sous reseau format comme un chiffre de 4 octets
  TicmpIPStatus    = Longword;                             // Code renvoy par les API.

  PIPOptionInformation = ^TIPOptionInformation;
  TIPOptionInformation = packed record
     TTL:         Byte;                                    // Time To Live (used for traceroute)
     TOS:         Byte;                                    // Type Of Service (usually 0)
     Flags:       Byte;                                    // IP header flags (usually 0)
     OptionsSize: Byte;                                    // Size of options data (usually 0, max 40)
     OptionsData: PChar;                                   // Options data buffer
  end;

  PIcmpEchoReply = ^TIcmpEchoReply;
  TIcmpEchoReply = packed record
     Address:       TicmpIPAddress;                        // Replying address
     Status:        longWord;                              // IP status value
     RTT:           longWord;                              // Round Trip Time in milliseconds
     DataSize:      Word;                                  // Reply data size
     Reserved:      Word;                                  // Reserved
     Data:          Pointer;                               // Pointer to reply data buffer
     Options:       TIPOptionInformation;                  // Reply options
  end;

//  ___________________________________________________________________________
// | Type TIcmpCreateFile = function                                           |
// | _________________________________________________________________________ |
// || squelette de l'API IcmpCreateFile                                       ||
// || cre un handle sur lequel des requtes ICMP peuvent tre adresses      ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties | result : Thandler                                             ||
// ||         |   Handler ouvert ou INVALID_HANDLE_VALUE en cas d'erreur voir ||
// ||         |   Getlasterror pour avoir des informations d'tailles        ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|
  TIcmpCreateFile = function: THandle; stdcall;

//  ___________________________________________________________________________
// | Type TIcmpCloseHandle = function                                          |
// | _________________________________________________________________________ |
// || squelette de l'API IcmpCloseHandle                                      ||
// || Ferme le handle ouvert par TicmpCreateFile                              ||
// ||_________________________________________________________________________||
// || Entres | IcmpHandle : THandle                                          ||
// ||         |   Handler  fermer                                            ||
// ||_________|_______________________________________________________________||
// || Sorties | result : Boolean                                              ||
// ||         |   True si andler bien ferm ou False en cas d'erreur voir     ||
// ||         |   Getlasterror pour avoir des informations d'tailles        ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|
  TIcmpCloseHandle = function(IcmpHandle: THandle): Boolean; stdcall;

//  ___________________________________________________________________________
// | Type TIcmpSendEcho = function                                             |
// | _________________________________________________________________________ |
// || squelette de l'API IcmpSendEcho                                         ||
// || Envoie une requte Echo et renvoie uns ou plusieurs reponses            ||
// ||_________________________________________________________________________||
// || Entres | IcmpHandle : THandle                                          ||
// ||         |   Handler ouvert par TicmpCreateFile                          ||
// ||         | DestinationAddress : TicmpIPAddress                           ||
// ||         |   Adresse de destination des requtes echo                    ||
// ||         | RequestData : Pointer                                         ||
// ||         |   Pointeur sur un tampon contenant les donnes envoyes par   ||
// ||         |   la requte                                                  ||
// ||         | RequestSize : Word                                            ||
// ||         |   Taille du tampon point par RequestData                     ||
// ||         | RequestOptions : PIPOptionInformation                         ||
// ||         |   Pointeur vers les options d'entte IP, doit tre nul        ||
// ||         | ReplyBuffer : Pointer                                         ||
// ||         |   Pointeur sur le tampon de receptions des rponses, le tampon||
// ||         |   doit pouvoir contenir au minimun un ICMP_ECHO_REPLY et 8    ||
// ||         |   octet, taille d'un message d'erreur                         ||
// ||         | ReplySize : DWord                                             ||
// ||         |   Taille du tampon point par ReplyBuffer                     ||
// ||         | Timeout : DWord                                               ||
// ||         |   Temps en milli secondes d'attente de rponses               ||
// ||_________|_______________________________________________________________||
// || Sorties | result : DWord                                                ||
// ||         |   Nombre de rponses obtenu, 0 en cas d'erreur voir           ||
// ||         |   Getlasterror pour avoir des informations d'tailles        ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|
  TIcmpSendEcho = function(IcmpHandle: THandle ;
                           DestinationAddress : TicmpIPAddress ;
                           RequestData : Pointer ;
                           RequestSize : Word ;
                           RequestOptions : PIPOptionInformation ;
                           ReplyBuffer : Pointer ;
                           ReplySize : longWord ;
                           Timeout : longWord ): longWord ; stdcall ;

//  ___________________________________________________________________________
// | Type TIcmpReply   = procedure                                             |
// | _________________________________________________________________________ |
// || squelette de la procedure  utiliser lors d'une rponse                 ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelent la procdure                                 ||
// ||         | Error : Integer                                               ||
// ||         |   Eventuel numro d'erreur suite au ping                      ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|
  TIcmpReply   = procedure(Sender: TObject; Error : Integer) of object;

  Tping = class(TObject)
  private

// ****************************************************************************
// * Dclarations prives                                                     *
// ****************************************************************************

    hDll : HModule;                            // Handle sur la DLL
    IcmpCreateFile : TIcmpCreateFile;          // Lien sur la fonction IcmpCreateFile
    IcmpCloseHandle : TIcmpCloseHandle;        // Lien sur la fonction IcmpCloseHandle
    IcmpSendEcho : TIcmpSendEcho;              // Lien sur la fonction IcmpSendEcho
    hICMP : THandle;                           // Handle de ping
    FIcmpEchoReply : TIcmpEchoReply;           // Tampon pour recevoir les rponses Echo
    FstrAddress : String;                      // Addresse IP fournie
    FstrHostName : String;                     // Nom d'hte rsolut
    FstrHostIP : String;                       // Adresse IP de l'hte rsolut sous forme WWW.XXX.YYY.ZZZ
    FicmpIPAddress : TicmpIPAddress;           // Address IP de l'hte
    FdwSize : Longword ;                       // taille des paquets (initialis  56)
    FdwTimeOut : Longword ;                    // Timeout (initialis  4000mS)
    FdwTTL : Longword;                         // Time To Live
    FFlags : Integer;                          // Options flags
    FOnEchoRequest : TNotifyEvent;             // Adresse de la fonction  appeller sur onEchoRequest
    FOnEchoReply : TICMPReply;                 // Adresse de la fonction  appeller sur onEchoReply
    FdwLastError : longword;                   // Derniere erreur
    FbooAddressResolved : Boolean;             // L'adresse de l'hte a bien t rsolut
    fdwLastRTT : Longword;                     // Temps de reponse du dernier ping
    fdwTotalRTT : longword;                    // Somme des temps de rponses
    fdwNbRepply : longword;                    // Nombres de rponses positives
    ffltRTT : Real ;                           // Temps de rponse moyen
    procedure ResolveAddress;
  public

// ****************************************************************************
// * Dclarations publiques                                                   *
// ****************************************************************************

    constructor Create; virtual;
    destructor  Destroy; override;
    function    Ping : Integer;
    procedure   SetAddress(strAddress : String);
    function    GetErrorString : String;

    property Address : String             read  FstrAddress    write SetAddress;
    property Size : longword              read  FdwSize        write FdwSize;
    property Timeout : longword           read  FdwTimeout     write FdwTimeout;
    property Reply : TIcmpEchoReply       read  FIcmpEchoReply;
    property TTL : longword               read  FdwTTL         write FdwTTL;
    Property Flags : Integer              read  FFlags         write FFlags;
    property ErrorCode : longWord            read  FdwLastError;
    property ErrorString : String         read  GetErrorString;
    property HostName : String            read  FstrHostName;
    property HostIP : String              read  FstrHostIP;
    property RTT : longword               read  fdwLastRTT ;
    property averageRTT : real            read  ffltRTT ;
    property OnEchoRequest : TNotifyEvent read  FOnEchoRequest write FOnEchoRequest;
    property OnEchoReply : TICMPReply     read  FOnEchoReply   write FOnEchoReply;
  end;

  TICMPException = class(Exception);

implementation

// #===========================================================================#
// #===========================================================================#
// #                                                                           #
// # Partie Prive                                                             #
// #                                                                           #
// #===========================================================================#
// #===========================================================================#

procedure Tping.ResolveAddress;

//  ___________________________________________________________________________
// | procedure TICMP.ResolveAddress                                            |
// | _________________________________________________________________________ |
// || Pemret de resoudre l'adresse fourni en adresse IP valide                ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  HostEnt : PHostEnt;
begin

// ****************************************************************************
// * C'est une adresse ip                                                     *
// ****************************************************************************

  FicmpIPAddress := inet_addr(PChar(FstrAddress));
  if FicmpIPAddress <> Longword(INADDR_NONE) then
    FstrHostName := FstrAddress
  else
  begin

// ****************************************************************************
// * Convertion du hostname en adresse IP                                     *
// ****************************************************************************

    HostEnt := GetHostByName(PChar(FstrAddress));
    if HostEnt = nil then
    begin
      FdwLastError := GetLastError;
      Exit;
    end;
    FicmpIPAddress := longint(plongint(HostEnt^.h_addr_list^)^);
    FstrHostName := HostEnt^.h_name;
  end;
  FstrHostIP := StrPas(inet_ntoa(TInAddr(FicmpIPAddress)));
  FbooAddressResolved := TRUE;
end;

// #===========================================================================#
// #===========================================================================#
// #                                                                           #
// # Partie Publique                                                           #
// #                                                                           #
// #===========================================================================#
// #===========================================================================#

constructor Tping.Create;

//  ___________________________________________________________________________
// | constructor TICMP.Create                                                  |
// | _________________________________________________________________________ |
// || Constructeur de la class TICMP permet d'initialiser certaine variable et||
// || charger la DLL IPHLPAPI.DLL ou ICMP.DLL en fonction de la disponibilit ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  WSAData: TWSAData;
begin
  hICMP      := INVALID_HANDLE_VALUE;
  FdwSize    := 56;
  FdwTTL     := 64;
  FdwTimeOut := 4000;

  if WSAStartup($101, WSAData) <> 0 then
      raise TICMPException.Create('Erreur lors de l''initialisation de Winsock');

// ****************************************************************************
// * Tentative de cration de la liaison dynamique avec IPHLPAPI.DLL puis avec*
// * ICMP.DLL en cas d'chec                                                  *
// ****************************************************************************

  hdll := LoadLibrary(IphlpapiDLL);
    if hdll = 0 then
    hdll := LoadLibrary(IcmpDLL );
    if hDll = 0 then
      raise TICMPException.Create('Impossible de trouver ' + icmpDLL + ' ou ' + IphlpapiDLL );

// ****************************************************************************
// * Chargement des fonctions                                                 *
// ****************************************************************************

  @ICMPCreateFile  := GetProcAddress(hdll, 'IcmpCreateFile');
  @IcmpCloseHandle := GetProcAddress(hdll, 'IcmpCloseHandle');
  @IcmpSendEcho    := GetProcAddress(hdll, 'IcmpSendEcho');
  if (@ICMPCreateFile = Nil) or (@IcmpCloseHandle = Nil) or (@IcmpSendEcho = Nil) then
    raise TICMPException.Create('Erreur lors du chargement des fonctions API');

// ****************************************************************************
// * Cration du handler de ping                                              *
// ****************************************************************************

  hICMP := IcmpCreateFile;
  if hICMP = INVALID_HANDLE_VALUE then
    raise TICMPException.Create('Impossible d''avoir le handlre de Ping');
end;



destructor Tping.Destroy;

//  ___________________________________________________________________________
// | destructor TICMP.Destroy                                                  |
// | _________________________________________________________________________ |
// || Destructeur de la class TICMP pemet de librrer les different handler   ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  if hICMP <> INVALID_HANDLE_VALUE then IcmpCloseHandle(hICMP);
  if hdll <> 0 then FreeLibrary(hdll);
  WSACleanup;
  inherited Destroy;
end;

procedure Tping.SetAddress(strAddress : String);

//  ___________________________________________________________________________
// | procedure TICMP.SetAddress(strAddress : String)                           |
// | _________________________________________________________________________ |
// || Permet de dfinir l'adresse IP                                          ||
// ||_________________________________________________________________________||
// || Entres | strAddress : String                                           ||
// ||         |   adresse ip ou nom d'hte  pinguer                          ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  if FstrAddress = strAddress then Exit;
  FstrAddress := strAddress;
  FbooAddressResolved := FALSE;
end;


function Tping.GetErrorString : String;

//  ___________________________________________________________________________
// | function TICMP.GetErrorString : String                                    |
// | _________________________________________________________________________ |
// || Permet de rccuperer le dtail de la derniere erreur lors de l'execution||
// || du ping                                                                 ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties | result : string                                               ||
// ||         |   dtail de l'erreur                                          ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  case FdwLastError of
    ICMP_SUCCESS                             : Result := 'No error';
    ICMP_STATUS_BUFFER_TO_SMALL              : Result := 'Buffer trop petit';
    ICMP_STATUS_DESTINATION_NET_UNREACH      : Result := 'Rseau de destination non atteignable';
    ICMP_STATUS_DESTINATION_HOST_UNREACH     : Result := 'Hte destination non atteignable';
    ICMP_STATUS_DESTINATION_PROTOCOL_UNREACH : Result := 'protocole de destination non atteignable';
    ICMP_STATUS_DESTINATION_PORT_UNREACH     : Result := 'port de destination non atteignable';
    ICMP_STATUS_NO_RESOURCE                  : Result := 'Pas de resources';
    ICMP_STATUS_BAD_OPTION                   : Result := 'Mauvaises options';
    ICMP_STATUS_HARDWARE_ERROR               : Result := 'Erreur matriel';
    ICMP_STATUS_LARGE_PACKET                 : Result := 'Paquet trop grand';
    ICMP_STATUS_REQUEST_TIMED_OUT            : Result := 'Request timed out';
    ICMP_STATUS_BAD_REQUEST                  : Result := 'Mauvaise requte';
    ICMP_STATUS_BAD_ROUTE                    : Result := 'Mauvaise route';
    ICMP_STATUS_TTL_EXPIRED_TRANSIT          : Result := 'TTL  expir pendant le trajet';
    ICMP_STATUS_TTL_EXPIRED_REASSEMBLY       : Result := 'TTL  expir pendant le rassemblage';
    ICMP_STATUS_PARAMETER                    : Result := 'Problme de paramtrages';
    ICMP_STATUS_SOURCE_QUENCH                : Result := 'Extinction de la source';
    ICMP_STATUS_OPTION_TOO_BIG               : Result := 'Options trop grandes';
    ICMP_STATUS_BAD_DESTINATION              : Result := 'Mauvaise destination';
    ICMP_STATUS_ADDR_DELETED                 : Result := 'Adresse supprime';
    ICMP_STATUS_SPEC_MTU_CHANGE              : Result := 'Les specifications MTU ont chang'; // (MTU Maximum Transmission Unit,taille maximale d'un paquet IP)
    ICMP_STATUS_MTU_CHANGE                   : Result := 'la taille maximale du paquet IP a chang';
    ICMP_STATUS_GENERAL_FAILURE              : Result := 'Erreur gnrale';
    ICMP_STATUS_PENDING                      : Result := 'Ping en cours';
    else
        Result := 'ICMP error #' + IntToStr(FdwLastError);
  end;
end;



function Tping.Ping : Integer;

//  ___________________________________________________________________________
// | function TICMP.Ping : Integer                                             |
// | _________________________________________________________________________ |
// || Permet d'executer un ping sur une adresse de destination                ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties | result : integer                                              ||
// ||         |   nombre de rponses reue 1 ok, 0 Erreur                     ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  BufferSize : Integer;
  pReqData, pData : Pointer;
  IcmpEchoReply : PIcmpEchoReply;
  IPOptionInformation : TIPOptionInformation;
  strMessage : String;
  tailleMSG : longword;
begin
  Result := 0;
  FdwLastError := 0;
  strMessage := 'Ping en cours ...';
  tailleMSG := length(strMessage);

  if not FbooAddressResolved then ResolveAddress;

  if FicmpIPAddress = Longword(INADDR_NONE) then
  begin
    FdwLastError := ICMP_STATUS_BAD_DESTINATION ;
    Exit;
  end;

// ****************************************************************************
// * Rservation mmoire pour les tampons                                     *
// ****************************************************************************

  BufferSize := SizeOf(TICMPEchoReply) + FdwSize;
  GetMem(pReqData,FdwSize);
  GetMem(pData,FdwSize);
  GetMem(IcmpEchoReply,BufferSize);

  try

// ****************************************************************************
// * Initialisation des tampons                                               *
// ****************************************************************************

    FillChar(pReqData^, FdwSize, $20);
    Move(strMessage[1], pReqData^,ifthen(FdwSize>=tailleMSG , tailleMSG ,FdwSize));
    IcmpEchoReply^.Data := pData;
    FillChar(IcmpEchoReply^, SizeOf(IcmpEchoReply^), 0);

    if Assigned(FOnEchoRequest) then FOnEchoRequest(Self);

    FillChar(IPOptionInformation, SizeOf(IPOptionInformation), 0);
    IPOptionInformation.TTL := FdwTTL;
    IPOptionInformation.Flags := FFlags;

    Result := IcmpSendEcho(hICMP, FicmpIPAddress, pReqData, FdwSize, @IPOptionInformation, IcmpEchoReply, BufferSize, FdwTimeOut);

    FdwLastError := GetLastError;
    FIcmpEchoReply := IcmpEchoReply^;

// ****************************************************************************
// * Calculs de stat sur les temps de rponses                                *
// ****************************************************************************

    if result <> 0 then
    begin
      fdwNbRepply := fdwNbRepply + 1;
      fdwLastRTT := FIcmpEchoReply.RTT;
      fdwTotalRTT := fdwTotalRTT + fdwLastRTT;
      ffltRTT := fdwTotalRTT / fdwNbRepply ;
    end;

    if Assigned(FOnEchoReply) then FOnEchoReply(Self, FdwLastError);
  finally

// ****************************************************************************
// * Libration de l'espace mmoire allou                                    *
// ****************************************************************************

    FreeMem(IcmpEchoReply);
    FreeMem(pData);
    FreeMem(pReqData);
  end;
end;

end.

