unit ufrmmaitre;

// |===========================================================================|
// | unit ufrmmaitre                                                           |
// | Copyright  2007 F.BASSO                                                  |
// |___________________________________________________________________________|
// | Unite de la fiche principale du logiciel fbPing                           |
// |___________________________________________________________________________|
// | Ce programme est libre, vous pouvez le redistribuer et ou le modifier     |
// | selon les termes de la Licence Publique Gnrale GNU publie par la       |
// | Free Software Foundation .                                                |
// | Ce programme est distribu car potentiellement utile,                     |
// | mais SANS AUCUNE GARANTIE, ni explicite ni implicite,                     |
// | y compris les garanties de commercialisation ou d'adaptation              |
// | dans un but spcifique.                                                   |
// | Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.    |
// |                                                                           |
// | anbasso@wanadoo.fr                                                        |
// |___________________________________________________________________________|
// | Versions                                                                  |
// | 1.1.0 ajout possibilit chargement fichier CSV |nom;type;@ip|             |
// | 1.0.0 Cration de l'unit                                                 |
// |===========================================================================|

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,ufrmentite, ImgList, ExtCtrls, Buttons,ufrmsaisie,udmxml,
  ufrmoption,registry,ufonctionsdiv,umail,ufrmsplash;

type
  Tfrmmaitre = class(TForm)
    pnlMenu: TPanel;
    cmdAjouter: TBitBtn;
    cmdSupprimer: TBitBtn;
    cmdSupprimerTous: TBitBtn;
    cmdQuitter: TBitBtn;
    cmdOptions: TBitBtn;
    cbxModif: TCheckBox;
    cmdOuvrir: TBitBtn;
    cmdNouveau: TBitBtn;
    cmdSauver: TBitBtn;
    OpenDialog: TOpenDialog;
    SaveDialog1: TSaveDialog;
    TimPing: TTimer;
    cmdPing: TBitBtn;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure cmdPingClick(Sender: TObject);
    procedure TimPingTimer(Sender: TObject);
    procedure cmdQuitterClick(Sender: TObject);
    procedure cmdOptionsClick(Sender: TObject);
    procedure cmdSauverClick(Sender: TObject);
    procedure cmdOuvrirClick(Sender: TObject);
    procedure cmdNouveauClick(Sender: TObject);
    procedure cmdSupprimerTousClick(Sender: TObject);
    procedure cmdSupprimerClick(Sender: TObject);
    procedure cmdAjouterClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private

// ****************************************************************************
// * Dclarations prives                                                     *
// ****************************************************************************

    intDistanceAvantDrag : integer;
    intTaillegrille : integer;
    strNomFichier : string;

    procedure SupprimerTout;
    function  getLastFichier : string;
    procedure sauveLastFichier ;
    procedure afficherCaption;
    procedure chargerCSV;
  public

// ****************************************************************************
// * Dclarations publiques                                                   *
// ****************************************************************************

    fboptions : toptions;
    entiteSelection : TfrmEntite ;
  end;

var
  frmmaitre: Tfrmmaitre;
  MousePoint: TPoint;

implementation

{$R *.dfm}

// #===========================================================================#
// #===========================================================================#
// #                                                                           #
// # Partie Prive                                                             #
// #                                                                           #
// #===========================================================================#
// #===========================================================================#

procedure Tfrmmaitre.chargerCSV ;

//  ___________________________________________________________________________
// | procedure Tfrmmaitre.chargerCSV                                           |
// | _________________________________________________________________________ |
// || Permet de crer un projet depuis un fichier CSV. le fichier CSV doit    ||
// || tre sous la forme NOM;TYPE;@IP                                         ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  Fichier : tstringlist;
  item    : tstringlist;
  machine : Tmachine ;
  i : integer;
  strType : string;

begin
  Fichier := TStringList.Create ;
  item := TStringList.Create;
  item.Delimiter := ';' ;

// ****************************************************************************
// * Chargement du fichier dans un stringlist                                 *
// ****************************************************************************

  Fichier.LoadFromFile(strNomFichier );
  for i := 0 to fichier.Count -1 do
  begin

// ****************************************************************************
// * Chaque ligne du fichier est dcoupe en trois morceaux en prenant comme  *
// * separateur le ';'                                                        *
// ****************************************************************************

    item.DelimitedText := fichier[i];

// ****************************************************************************
// * Rcupration du nom dans la premiere partie et de l'adresse IP dans la 3 *
// ****************************************************************************

    machine.strNom := item[0];
    machine.strHost := item[2];
    machine.booControler := true;
    machine.y := 0;
    machine.x := (i+1) * 120;

// ****************************************************************************
// * Rcupration du type dans la seconde partie et convertion en ttypemachine*
// ****************************************************************************

    strtype := lowercase(item[1]);
    if strtype = 'ordinateur' then machine.typeMachine := tmOrdinateur else
      if strtype = 'serveur' then machine.typeMachine := tmServeur else
        if strtype = 'switch' then machine.typeMachine := tmSwitch else
          if strtype = 'imprimante' then machine.typeMachine := tmImprimante else
            machine.typeMachine := tmOrdinateur ;
    try

// ****************************************************************************
// * Tentative de cration de la nouvelle entit                              *
// ****************************************************************************

      TfrmEntite.create(self,machine);
    except
      on e:exception do
        messagedlg('Erreur lors de la cration de l''lment' + #10#13 +
                   'Nom : ' + item[0] + #10#13 +
                   'Type : ' + item[1] + #10#13 +
                   '@IP : ' + item[2] + #10#13 +
                   e.Message ,mterror,[mbok],0);
    end;
  end;
  freeandnil(item);
  freeandnil(fichier);
end;

procedure Tfrmmaitre.afficherCaption ;

//  ___________________________________________________________________________
// | procedure Tfrmmaitre.afficherCaption                                      |
// | _________________________________________________________________________ |
// || Permet de modifier le caption de la fentre principale en fonction de la||
// || version, du copyright et du nom de fichier ouvert                       ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  caption := 'FB_PING V' + StrLectureVersion + ' ' + StrLectureCopyright + ' [' + extractfilename(strNomFichier)  + ']';
end;

function  Tfrmmaitre.getLastFichier : string;

//  ___________________________________________________________________________
// | function  Tfrmmaitre.getLastFichier                                       |
// | _________________________________________________________________________ |
// || permet de reccuperer dans la base de registre le nom du dernier fichier ||
// || ouvert                                                                  ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties | result : string                                               ||
// ||         |   Nom du dernier fichier ouvert, vide si pas de fichier       ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  registre : TRegistry ;
begin
  registre := Tregistry.Create(KEY_ALL_ACCESS );
  result :='';
  try
    registre.RootKey := HKEY_CURRENT_USER ;
    registre.OpenKey('\Software\F.BASSO\FB_PING',false);
    if registre.ValueExists('LastFfile') then
      result := registre.ReadString('LastFfile');
  except
  end;
  FreeAndNil(registre);
end;

procedure Tfrmmaitre.sauveLastFichier ;

//  ___________________________________________________________________________
// | procedure Tfrmmaitre.sauveLastFichier                                     |
// | _________________________________________________________________________ |
// || Permet de sauvegarder le nom du fichier en cours dans la base de        ||
// || registre au niveau du profile utilisateur                               ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  registre : TRegistry ;
begin
  registre := Tregistry.Create(KEY_ALL_ACCESS );
  try
    registre.RootKey := HKEY_CURRENT_USER ;
    registre.OpenKey('\Software\F.BASSO\FB_PING',true);
    registre.WriteString('LastFfile',strNomFichier);
  except
  end;
  FreeAndNil(registre);
end;

procedure Tfrmmaitre.SupprimerTout ;

//  ___________________________________________________________________________
// | procedure Tfrmmaitre.SupprimerTout                                        |
// | _________________________________________________________________________ |
// || Permet de supprimer toutes les entits                                  ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var i : integer;
begin

// ****************************************************************************
// * On liste tout les controles prsent sur la form                          *
// ****************************************************************************

  for i := ControlCount -1 downto 0 do

// ****************************************************************************
// * Le control est un Tfrmentite on le supprime                              *
// ****************************************************************************

    if controls[i] is TfrmEntite then
    begin
      entiteSelection := TfrmEntite ( controls[i]);
      freeandnil (entiteSelection );
    end;
end;


// #===========================================================================#
// #===========================================================================#
// #                                                                           #
// # Partie Evenementielle                                                     #
// #                                                                           #
// #===========================================================================#
// #===========================================================================#


procedure Tfrmmaitre.FormCreate(Sender: TObject);

//  ___________________________________________________________________________
// | procedure Tfrmmaitre.FormCreate                                           |
// | _________________________________________________________________________ |
// || Permet au cvhargement de la form d'iniitailiser toutes les donnes et si||
// |  l'option est coch de recharger le dernier fichier ouvert               ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant la procedure                                 ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin

// ****************************************************************************
// * Affichage du Splash                                                      *
// ****************************************************************************

  afficherCaption;
  TfrmSplash.Executer ;
  TfrmSplash.AfficheMessage('Chargement de la configuration ...');

// ****************************************************************************
// * initialisation de la grille                                              *
// ****************************************************************************

  intTaillegrille := 10;
  intDistanceAvantDrag := 0;
  TfrmEntite.setDistanceAvantDrag(intDistanceAvantDrag);
  TfrmEntite.setTaillegrille(intTaillegrille );
  cbxModif.Checked := false;
  strNomFichier := '';

// ****************************************************************************
// * Cration des autre modules et rcupration des options                   *
// ****************************************************************************

  frmOption := TfrmOption.Create(application);
  dtXML     := TdtXML.Create(application);
  fboptions := frmoption.getoptions ;
  TfrmSplash.AfficheMessage('Configuration charge');
  visible:=true;
  application.ProcessMessages ;

// ****************************************************************************
// * Rechargement du dernier fichier si option valide                        *
// ****************************************************************************

  if fboptions.booReloadFile then
  begin
    strNomFichier := getLastFichier ;
    TfrmSplash.AfficheMessage('Chargement de ' +ExtractFileName( strNomFichier) + ' en cours ...');
    if FileExists(strNomFichier ) then
    begin
      dtXML.Charger(strNomFichier );
      TfrmSplash.AfficheMessage('Chargement de ' +ExtractFileName( strNomFichier) + ' termin');
    end else
    begin
      TfrmSplash.AfficheMessage('/!\ ' +ExtractFileName( strNomFichier) + ' dplac ou supprim ouverture annule');
      strnomfichier := '';
    end;
  end;
  TimPing.Interval := fboptions.intIntervalle *1000;
  timping.Enabled := true;
  afficherCaption;
  ecritlog('Demarrage ' + caption);
  TfrmSplash.Ferme ;
end;

procedure Tfrmmaitre.FormPaint(Sender: TObject);

//  ___________________________________________________________________________
// | procedure Tfrmmaitre.FormPaint                                            |
// | _________________________________________________________________________ |
// || Permet de dessiner la grille sur le fond                                ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant la procedure                                 ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  i , j : integer;
begin
  j := 0;
  visible := true;
  while j < Clientheight do
  begin
    i := 0;
    while i < ClientWidth do
    begin
      Canvas.Pixels[i,j] := clblack;
      i := i + intTaillegrille ;
    end;
    j:= j + intTaillegrille ;
  end;
end;

procedure Tfrmmaitre.cmdAjouterClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure Tfrmmaitre.cmdAjouterClick                                      |
// | _________________________________________________________________________ |
// || Permet d'ajouter une nouvelle entit                                    ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant la procedure                                 ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  machine : Tmachine ;
begin
  if TfrmSaisie.getInformation(machine) then
  begin
    TfrmEntite.create(self,machine);
    cbxModif.Checked := true;
  end;
end;

procedure Tfrmmaitre.cmdSupprimerClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure Tfrmmaitre.cmdSupprimerClick                                    |
// | _________________________________________________________________________ |
// || Supprime l'entit slectionne                                          ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant la procedure                                 ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  if entiteSelection <> nil then
  begin
    if MessageDlg('Etes vous sur de vouloir supprimer ' + #10 + #13 +
                   entiteSelection.getstrType  + ' ' + entiteSelection.getNom ,
                   mtConfirmation ,[mbok,mbcancel],0) = mrok then
    begin
      FreeAndNil (entiteSelection );
      cbxModif.Checked := true;
    end;
  end;
end;

procedure Tfrmmaitre.cmdSupprimerTousClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure Tfrmmaitre.cmdSupprimerTousClick                                |
// | _________________________________________________________________________ |
// || Permet de supprimer toutes les entits apres validation                 ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant la procedure                                 ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  if ControlCount > 2 then
  if MessageDlg('Etes vous sur de vouloir supprimer tout les objets ?',
                   mtConfirmation ,[mbok,mbcancel],0) = mrok then
  begin
    SupprimerTout ;
    cbxModif.Checked := true;
  end;
end;

procedure Tfrmmaitre.cmdNouveauClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure Tfrmmaitre.cmdNouveauClick                                      |
// | _________________________________________________________________________ |
// || Permet de crer un nouveau projet                                       ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant la procedure                                 ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  if cbxModif.Checked then
    if messagedlg('Vous n''avez pas enregistr les modifications' +
                  #10 + #13 + 'Etes vous sur de vouloir crer un nouveau document ?',
                  mtConfirmation ,[mbok,mbcancel],0) = mrcancel then exit;
  SupprimerTout ;
  strNomFichier :='';
  afficherCaption;
  EcritLog('Cration d''un nouveau fichier' );
end;

procedure Tfrmmaitre.cmdOuvrirClick(Sender: TObject );

//  ___________________________________________________________________________
// | procedure Tfrmmaitre.cmdOuvrirClick                                       |
// | _________________________________________________________________________ |
// || Permet d'ouvrir un fichier projet ou un CSV                             ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant la procedure                                 ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  if cbxModif.Checked then
    if messagedlg('Vous n''avez pas enregistr les modifications' +
                  #10 + #13 + 'Etes vous sur de vouloir ouvrir un document ?',
                  mtConfirmation ,[mbok,mbcancel],0) = mrcancel then exit;
  if OpenDialog.Execute then
  begin
    cbxModif.Checked := false;
    SupprimerTout ;
    strNomFichier := OpenDialog.FileName ;
    if ExtractFileExt(strnomfichier) = '.fbping' then
    begin
      dtXML.Charger(strNomFichier );
      sauveLastFichier;
    end else
    if ExtractFileExt(strnomfichier) = '.csv' then
    begin
      chargerCsv;
      strnomfichier := '';
      cbxModif.Checked := true;
    end;
  end;
  afficherCaption;
  EcritLog('ouverture de ' + strNomFichier );
end;

procedure Tfrmmaitre.cmdSauverClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure Tfrmmaitre.cmdSauverClick                                       |
// | _________________________________________________________________________ |
// || Pemret de sauvegarder le projet                                         ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant la procedure                                 ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  SaveDialog1.FileName := strNomFichier ;
  if SaveDialog1.Execute then
  begin
    if strNomFichier <> SaveDialog1.FileName then
      if messagedlg('Etes vous sur de vouloir ecraser le fichier <' +  SaveDialog1.FileName +'>'+ #10#13 +
                    'par le fichier actuel <' +  strNomFichier + '>' ,mtConfirmation ,[mbok,mbcancel],0) = mrCancel then exit;
    strNomFichier := SaveDialog1.FileName ;
    dtXML.Sauver(strNomFichier );
    cbxModif.Checked :=false;
    sauveLastFichier;
  end;
  afficherCaption;
  EcritLog('sauvegarde de ' + strNomFichier );
end;

procedure Tfrmmaitre.cmdOptionsClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure Tfrmmaitre.cmdOptionsClick                                      |
// | _________________________________________________________________________ |
// || Permet de modifier les options de l'application et du projet en cours   ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant la procedure                                 ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var temp : Toptions ;
begin
  TimPing.Enabled := false;
  temp := fboptions ;
  frmOption.modifOtptions(fboptions);
  cbxModif.Checked := ( temp.booMail  <> fboptions.booMail ) or
                      ( temp.strFrom <> fboptions.strFrom )or
                      ( temp.tabStrMail <> fboptions.tabStrMail );
  TimPing.Enabled := true;
end;

procedure Tfrmmaitre.cmdQuitterClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure Tfrmmaitre.cmdQuitterClick                                      |
// | _________________________________________________________________________ |
// || Permet de quiter l'application                                          ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant la procedure                                 ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  close;
end;

procedure Tfrmmaitre.TimPingTimer(Sender: TObject);

//  ___________________________________________________________________________
// | procedure Tfrmmaitre.TimPingTimer                                         |
// | _________________________________________________________________________ |
// || Lance  interval rgulier un ping de toutes les entits                 ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant la procedure                                 ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  i : integer;
  temp : tfrmentite;
  strTemp : string;
  infomessage : Tmessage ;
begin
  TimPing.Enabled := false;
  cmdPing.Enabled := false;

// ****************************************************************************
// * On liste tout les controles prsent sur la form                          *
// ****************************************************************************

  for i:= 0 to ControlCount -1 do

// ****************************************************************************
// * Le control est un Tfrmentite on lance le ping                            *
// ****************************************************************************

    if controls[i] is TfrmEntite then
    begin
      temp := controls[i] as TfrmEntite ;
      temp.booPing ;
    end;

// ****************************************************************************
// * Y a t'il un message  envoyer                                            *
// ****************************************************************************

  strtemp := TfrmEntite.getMessage ;
  if (strtemp <>'') and fboptions.booMail then
  begin

// ****************************************************************************
// * Chargement des destinataires et construction du message                  *
// ****************************************************************************

    SetLength(infomessage.tabStrTo,length(fboptions.tabStrMail));
    for i := 0 to length(fboptions.tabStrMail) - 1 do
      infomessage.tabStrTo[i]    := fboptions.tabStrMail[i];
    infomessage.strMessage  := strTemp ;
    infomessage.intPortSmtp := fboptions.intPort ;
    infomessage.strAddrSmtp := fboptions.strAddrSmtp ;
    infomessage.strFrom     := fboptions.strFrom ;

// ****************************************************************************
// * envoie du message                                                        *
// ****************************************************************************

    envoyerMail (infomessage );
  end;
  cmdPing.Enabled := true;
  TimPing.Enabled := true;
end;

procedure Tfrmmaitre.cmdPingClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure Tfrmmaitre.cmdPingClick                                         |
// | _________________________________________________________________________ |
// || Permet de lancer un ping manuel                                         ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant la procedure                                 ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  TimPingTimer(nil);
end;

procedure Tfrmmaitre.FormCloseQuery(Sender: TObject; var CanClose: Boolean);

//  ___________________________________________________________________________
// | procedure Tfrmmaitre.FormCloseQuery                                       |
// | _________________________________________________________________________ |
// || Demande  l'utilisateur s'il veut quitter malgres qu'il y ait des       ||
// || modifications non enregistres                                          ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant la procedure                                 ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  if cbxModif.Checked then
    CanClose := messagedlg('Vous n''avez pas enregistr les modifications' +
                  #10 + #13 + 'Etes vous sur de vouloir quitter fb_Ping ?',
                  mtConfirmation ,[mbok,mbcancel],0) = mrok;
  if canclose then EcritLog('Arrt du programme');
end;

end.
