unit ufrmOption;

// |===========================================================================|
// | unit ufrmOption                                                           |
// | dvelopp par F.BASSO 2007                                                |
// | Formulaire de gestion des options de l'application FBPing                 |
// |___________________________________________________________________________|
// | Ce programme est libre, vous pouvez le redistribuer et ou le modifier     |
// | selon les termes de la Licence Publique Gnrale GNU publie par la       |
// | Free Software Foundation .                                                |
// | Ce programme est distribu car potentiellement utile,                     |
// | mais SANS AUCUNE GARANTIE, ni explicite ni implicite,                     |
// | y compris les garanties de commercialisation ou d'adaptation              |
// | dans un but spcifique.                                                   |
// | Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.    |
// |                                                                           |
// | anbasso@wanadoo.fr                                                        |
// |___________________________________________________________________________|
// | Versions                                                                  |
// |   1.0.0.0 Cration de l'unit                                             |
// |===========================================================================|


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Spin;

type
  Toptions = record
    intIntervalle : integer;
    booMail : boolean;
    intPort : integer;
    strAddrSmtp : string;
    strFrom : string;
    tabStrMail : array of string;
    booReloadFile : boolean;
  end;
  TfrmOption = class(TForm)
    cmdOK: TButton;
    grbApplication: TGroupBox;
    intIntervale: TSpinEdit;
    Label5: TLabel;
    cbxReloadFile: TCheckBox;
    grbProjet: TGroupBox;
    pnlOptionMail: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    txtFrom: TEdit;
    lstMail: TListBox;
    CmdSupprimer: TBitBtn;
    txtAdresse: TEdit;
    cmdSave: TBitBtn;
    cbxMail: TCheckBox;
    Label3: TLabel;
    txtSmtp: TEdit;
    Label4: TLabel;
    txtPort: TEdit;
    procedure txtChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure cbxReloadFileClick(Sender: TObject);
    procedure cmdOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CmdSupprimerClick(Sender: TObject);
    procedure cmdSaveClick(Sender: TObject);
    procedure lstMailClick(Sender: TObject);
    procedure txtAdresseChange(Sender: TObject);
    procedure cbxMailClick(Sender: TObject);
  private
    { Dclarations prives }
    fbOptions : Toptions ;
  public
    { Dclarations publiques }
    procedure chargerOptions(var options : Toptions );
    procedure sauverOptions( options : Toptions) ;
    function  getoptions : Toptions ;
    procedure modifOtptions(var options :Toptions );
  end;

var
  frmOption: TfrmOption;

implementation

{$R *.dfm}
uses inifiles;

procedure TfrmOption.chargerOptions(var options : Toptions ) ;

//  ___________________________________________________________________________
// | procedure TfrmOption.chargerOptions                                       |
// | _________________________________________________________________________ |
// || Permet de charger les options depuis un fichier INI                     ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties | var options : Toptions                                        ||
// ||         |   options charges                                            ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  fini : tinifile;
begin
  fIni := TIniFile.Create(ChangeFileExt(Application.ExeName, '.INI'));
  options.intIntervalle := fini.ReadInteger('General','intervalle',30);
  options.booReloadFile := fini.ReadBool('General','reloadfile',false);
  options.intPort := fini.ReadInteger('General','Port',25);
  options.strAddrSmtp := fini.ReadString('General','smtp','');
  fini.Free ;
end;

procedure TfrmOption.sauverOptions( options : Toptions) ;

//  ___________________________________________________________________________
// | procedure TfrmOption.sauverOptions                                        |
// | _________________________________________________________________________ |
// || Permet de sauvegarder les options dans un fichier INI                   ||
// ||_________________________________________________________________________||
// || Entres | options : Toptions                                            ||
// ||         |   options  sauvegarder                                       ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  fini : tinifile;
begin
  fIni := TIniFile.Create(ChangeFileExt(Application.ExeName, '.INI'));
  fini.WriteInteger('General','intervalle',options.intIntervalle );
  fini.WriteBool('General','reloadfile',options.booReloadFile);
  fini.writeInteger('General','Port',options.intPort);
  fini.writeString('General','smtp',options.strAddrSmtp);
  fini.Free ;
end;

function TfrmOption.getoptions : Toptions ;

//  ___________________________________________________________________________
// | function TfrmOption.getoptions                                            |
// | _________________________________________________________________________ |
// || permet de rcuprer les options                                         ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties | Result : Toptions                                             ||
// ||         |   options                                                     ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  Result := fbOptions;
end;

procedure TfrmOption.modifOtptions(var options :Toptions );

//  ___________________________________________________________________________
// | procedure TfrmOption.modifOtptions                                        |
// | _________________________________________________________________________ |
// || permet d'afficher les options actuelles et de les modifier              ||
// ||_________________________________________________________________________||
// || Entres | var options :Toptions                                         ||
// ||         |   options  modifer                                           ||
// ||_________|_______________________________________________________________||
// || Sorties | var options :Toptions                                         ||
// ||         |   options modifies                                           ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  fbOptions := options;
  ShowModal ;
  options := fbOptions ;
end;

procedure TfrmOption.cbxMailClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmOption.cbxMailClick                                         |
// | _________________________________________________________________________ |
// || permet d'activer ou non la zone de saisie des information de mail       ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant                                              ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  pnlOptionMail.Enabled := cbxMail.Checked;
  fboptions.booMail := cbxMail.Checked ;
end;

procedure TfrmOption.txtAdresseChange(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmOption.txtAdresseChange                                     |
// | _________________________________________________________________________ |
// || permet d'activer le bouton d'ajout d'adresse mail                       ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant                                              ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  cmdSave.Enabled := txtAdresse.Text  <> '';
  fboptions.strFrom := txtFrom.Text ;
end;

procedure TfrmOption.lstMailClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmOption.lstMailClick                                         |
// | _________________________________________________________________________ |
// || permet d'activer le bouton de suppression d'adresse                     ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant                                              ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  CmdSupprimer.Enabled := lstMail.ItemIndex > -1;
end;

procedure TfrmOption.cmdSaveClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmOption.cmdSaveClick                                         |
// | _________________________________________________________________________ |
// || Permet d'ajouter une nouvelle adresse de destination                    ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant                                              ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  setlength(fboptions.tabStrMail ,length(fboptions.tabStrMail)+1);
  fboptions.tabStrMail[length(fboptions.tabStrMail)-1]:=txtAdresse.Text ;
  sauverOptions(fboptions);
  FormShow (self);
end;

procedure TfrmOption.CmdSupprimerClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmOption.CmdSupprimerClick                                    |
// | _________________________________________________________________________ |
// || permet de supprimer l'adresse de destination slectionnes              ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant                                              ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  i : integer;
begin
  if lstmail.ItemIndex > -1 then
  begin
    for i:= lstmail.ItemIndex to lstmail.Items.Count -2 do
      fboptions.tabStrMail[i] := fboptions.tabStrMail[i+1];
    setlength(fboptions.tabStrMail,lstmail.Items.Count -1 );
  end;
  sauverOptions(fboptions);
  FormShow(self);
  lstMailClick(nil);
end;

procedure TfrmOption.FormCreate(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmOption.FormCreate                                           |
// | _________________________________________________________________________ |
// || Charge les option  la cration de la form                              ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant                                              ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  chargerOptions(fboptions);
end;

procedure TfrmOption.cmdOKClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmOption.cmdOKClick                                           |
// | _________________________________________________________________________ |
// || Permet de sauvegarder les options et ferme la form                      ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant                                              ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  sauverOptions(fboptions);
end;

procedure TfrmOption.cbxReloadFileClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmOption.cbxReloadFileClick                                   |
// | _________________________________________________________________________ |
// || Permet de modifier l'option booReloadFile                               ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant                                              ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  fboptions.booReloadFile := cbxReloadFile.Checked ;
end;

procedure TfrmOption.FormShow(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmOption.FormShow                                             |
// | _________________________________________________________________________ |
// || Permet de remplire les champ avec les options  l'affichage de la form  ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant                                              ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  i : integer;
begin
  grbApplication.Enabled := false;
  lstMail.Items.Clear ;
  txtAdresse.Text := '';
  cbxReloadFile.Checked := fbOptions.booReloadFile ;
  intIntervale.Value := fbOptions.intIntervalle ;
  cbxMail.Checked := fbOptions.booMail ;
  txtFrom.text := fboptions.strFrom ;
  for i :=0 to length(fboptions.tabStrMail)-1 do
    lstMail.Items.Add(fboptions.tabStrMail[i]);
  txtSmtp.Text := fboptions.strAddrSmtp ;
  txtPort.text := inttostr(fbOptions.intport);
  cbxMailClick(self);
  grbApplication.Enabled := true;
end;

procedure TfrmOption.txtChange(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmOption.txtChange                                            |
// | _________________________________________________________________________ |
// || Permet de mettre  jour les options modifies                           ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant                                              ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  if not grbApplication.Enabled then exit;
  fboptions.intPort := strtoint(txtPort.Text );
  fboptions.strAddrSmtp := txtSmtp.Text ;
  fbOptions.intIntervalle := intIntervale.Value ;
  fbOptions.strFrom := txtfrom.Text ;
end;

end.
